"use strict";
exports.__esModule = true;
var request = require("request");
var typescriptDeferred = require("typescript-deferred");
var USMART = (function () {
    function USMART(auth) {
        this.authInfo = auth;
    }
    USMART.prototype.request = function (organisation, resource, revision) {
        var url = this.buildURL(organisation, resource, revision);
        var headers;
        if (this.authInfo) {
            headers = {
                "api-key-id": this.authInfo.keyId,
                "api-key-secret": this.authInfo.keySecret
            };
        }
        var deferred = typescriptDeferred.create();
        request.get({
            headers: headers,
            url: url
        }, function (error, response, body) {
            if (error) {
                deferred.reject(body);
            }
            else {
                deferred.resolve(body);
            }
        });
        return deferred.promise;
    };
    USMART.prototype.buildURL = function (organisation, resource, revision) {
        return "https://api.usmart.io/org/" + organisation + "/" + resource + "/" +
            (revision ? revision + "/" : "latest/") + "urql?limit(1)";
    };
    return USMART;
}());
exports.USMART = USMART;
